/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.gebietsbaum.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class GebietPolygonPointTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.Long position;
    public java.lang.Long getPosition(){
      return position;
    }
  protected final de.ivu.elect.business.gebietsbaum.entity.GebietTK gebietTK;
    public de.ivu.elect.business.gebietsbaum.entity.GebietTK getGebietTK(){
      return gebietTK;
    }

  public GebietPolygonPointTK(
java.lang.Long position
,   de.ivu.elect.business.gebietsbaum.entity.GebietTK gebietTK
  ) {
    super();


      this.position = position;
        this.gebietTK = gebietTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((position == null) ? 0 : position.hashCode());
        
                    result = result + ((gebietTK == null) ? 0 : gebietTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof GebietPolygonPointTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        GebietPolygonPointTK other = (GebietPolygonPointTK) obj;

                if (position == null) {
          if (other.position != null) {
            return false;
          }
        } else if (!position.equals(other.position)) {
          return false;
        }
        
                if (gebietTK == null) {
          if (other.gebietTK != null) {
            return false;
          }
        } else if (!gebietTK.equals(other.gebietTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return GebietPolygonPointConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gebietTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(GebietPolygonPointConstants.MESSAGE_KEY_ENTITY_EINZAHL, GebietPolygonPointConstants.MESSAGE_KEY_POSITION_EINZAHL, position));
        
        return result;
      }


            @Override
            public String toString() {
            return "GebietPolygonPointTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"position="+position
                                        +", gebietTK="+gebietTK
            
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(GebietPolygonPointConstants.MESSAGE_KEY_POSITION_EINZAHL) + "=" + position
                                      + ", " +  toStringLokalisiert(gebietTK, messages)
                                 ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends GebietPolygonPoint> java.util.Map<GebietPolygonPointTK, E> mappeGebietPolygonPointNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(GebietPolygonPoint::getGebietPolygonPointTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<GebietPolygonPoint, GebietPolygonPointTK> getGebietPolygonPointToTKFunction() {
                return GebietPolygonPoint::getGebietPolygonPointTK;
                }

}
